# Generated by Django 3.0.6 on 2020-08-12 19:28

import django.core.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("inte_lists", "0006_auto_20200812_0317"),
        ("inte_subject", "0024_auto_20200812_0350"),
    ]

    operations = [
        migrations.RenameField(
            model_name="healtheconomicsrevised",
            old_name="rx_arv_cost_month",
            new_name="rx_hiv_cost_month",
        ),
        migrations.RenameField(
            model_name="historicalhealtheconomicsrevised",
            old_name="rx_arv_cost_month",
            new_name="rx_hiv_cost_month",
        ),
        migrations.RemoveField(
            model_name="healtheconomicsrevised", name="rx_arv_recv_month",
        ),
        migrations.RemoveField(
            model_name="healtheconomicsrevised", name="rx_diabetes_recv_month",
        ),
        migrations.RemoveField(
            model_name="healtheconomicsrevised", name="rx_hypertension_recv_month",
        ),
        migrations.RemoveField(
            model_name="healtheconomicsrevised", name="rx_other_recv_month",
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_diabetes_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive drugs for raised blood sugar (diabetes)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_diabetes_paid_month",
            field=models.ManyToManyField(
                blank=True,
                related_name="_healtheconomicsrevised_rx_diabetes_paid_month_+",
                to="inte_lists.DrugPaySources",
                verbose_name="If YES, received raised blood sugar (diabetes) drugs, how were these paid for?",
            ),
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_hiv_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive drugs for ARTs (HIV)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_hiv_paid_month",
            field=models.ManyToManyField(
                blank=True,
                max_length=25,
                related_name="_healtheconomicsrevised_rx_hiv_paid_month_+",
                to="inte_lists.DrugPaySources",
                verbose_name="If YES, received ARV (HIV) drugs, how were these paid for?",
            ),
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_hypertension_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive drugs for raised blood pressure (hypertension)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_hypertension_paid_month",
            field=models.ManyToManyField(
                blank=True,
                related_name="_healtheconomicsrevised_rx_hypertension_paid_month_+",
                to="inte_lists.DrugPaySources",
                verbose_name="If YES, received high blood pressure (Hypertension) drugs, how were these paid for?",
            ),
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_other_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive 'other' drugs?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="healtheconomicsrevised",
            name="rx_other_paid_month",
            field=models.ManyToManyField(
                blank=True,
                related_name="_healtheconomicsrevised_rx_other_paid_month_+",
                to="inte_lists.DrugPaySources",
                verbose_name="If YES, received 'other' drugs, how were these paid for?",
            ),
        ),
        migrations.AddField(
            model_name="historicalhealtheconomicsrevised",
            name="rx_diabetes_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive drugs for raised blood sugar (diabetes)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalhealtheconomicsrevised",
            name="rx_hiv_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive drugs for ARTs (HIV)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalhealtheconomicsrevised",
            name="rx_hypertension_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive drugs for raised blood pressure (hypertension)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalhealtheconomicsrevised",
            name="rx_other_month",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                default="Yes",
                max_length=15,
                verbose_name="Did you receive 'other' drugs?",
            ),
            preserve_default=False,
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="education_certificate",
            field=models.CharField(
                blank=True,
                max_length=50,
                null=True,
                verbose_name="What is your highest education certificate?",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="education_in_years",
            field=models.IntegerField(
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(50),
                ],
                verbose_name="How many years of education did you complete?",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="higher_education",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                max_length=15,
                verbose_name="Did you go to higher education?",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="household_income_per_month",
            field=models.IntegerField(
                help_text="in local currency",
                verbose_name="What is the total income in your household per month?",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="income_per_month",
            field=models.IntegerField(
                help_text="in local currency",
                verbose_name="How much do you earn (take home) per month?",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="primary_school",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                max_length=15,
                verbose_name="Did you go to primary/elementary school?",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="primary_school_in_years",
            field=models.IntegerField(
                blank=True,
                null=True,
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(10),
                ],
                verbose_name="If YES, for how many years",
            ),
        ),
        migrations.AlterField(
            model_name="healtheconomicsrevised",
            name="secondary_school",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                max_length=15,
                verbose_name="Did you go to secondary school?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="education_certificate",
            field=models.CharField(
                blank=True,
                max_length=50,
                null=True,
                verbose_name="What is your highest education certificate?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="education_in_years",
            field=models.IntegerField(
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(50),
                ],
                verbose_name="How many years of education did you complete?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="higher_education",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                max_length=15,
                verbose_name="Did you go to higher education?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="household_income_per_month",
            field=models.IntegerField(
                help_text="in local currency",
                verbose_name="What is the total income in your household per month?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="income_per_month",
            field=models.IntegerField(
                help_text="in local currency",
                verbose_name="How much do you earn (take home) per month?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="primary_school",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                max_length=15,
                verbose_name="Did you go to primary/elementary school?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="primary_school_in_years",
            field=models.IntegerField(
                blank=True,
                null=True,
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(10),
                ],
                verbose_name="If YES, for how many years",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhealtheconomicsrevised",
            name="secondary_school",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                max_length=15,
                verbose_name="Did you go to secondary school?",
            ),
        ),
    ]
