# Generated by Django 3.0.9 on 2020-09-09 16:56

from django.db import migrations, models
import edc_model.models.fields.duration


class Migration(migrations.Migration):

    dependencies = [
        ("inte_lists", "0006_auto_20200812_0317"),
        ("inte_subject", "0046_auto_20200904_2115"),
    ]

    operations = [
        migrations.AddField(
            model_name="diabetesinitialreview",
            name="dx_date",
            field=models.DateField(
                blank=True,
                help_text="If possible, provide the exact date here instead of estimating above.",
                null=True,
                verbose_name="Date patient diagnosed",
            ),
        ),
        migrations.AddField(
            model_name="historicaldiabetesinitialreview",
            name="dx_date",
            field=models.DateField(
                blank=True,
                help_text="If possible, provide the exact date here instead of estimating above.",
                null=True,
                verbose_name="Date patient diagnosed",
            ),
        ),
        migrations.AddField(
            model_name="historicalhivinitialreview",
            name="dx_date",
            field=models.DateField(
                blank=True,
                help_text="If possible, provide the exact date here instead of estimating above.",
                null=True,
                verbose_name="Date patient diagnosed",
            ),
        ),
        migrations.AddField(
            model_name="historicalhypertensioninitialreview",
            name="dx_date",
            field=models.DateField(
                blank=True,
                help_text="If possible, provide the exact date here instead of estimating above.",
                null=True,
                verbose_name="Date patient diagnosed",
            ),
        ),
        migrations.AddField(
            model_name="hivinitialreview",
            name="dx_date",
            field=models.DateField(
                blank=True,
                help_text="If possible, provide the exact date here instead of estimating above.",
                null=True,
                verbose_name="Date patient diagnosed",
            ),
        ),
        migrations.AddField(
            model_name="hypertensioninitialreview",
            name="dx_date",
            field=models.DateField(
                blank=True,
                help_text="If possible, provide the exact date here instead of estimating above.",
                null=True,
                verbose_name="Date patient diagnosed",
            ),
        ),
        migrations.AlterField(
            model_name="clinicalreviewbaseline",
            name="hiv_dx",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                editable=False,
                max_length=15,
                null=True,
                verbose_name="Was the patient diagnosed with HIV infection?",
            ),
        ),
        migrations.AlterField(
            model_name="diabetesinitialreview",
            name="dx_ago",
            field=edc_model.models.fields.duration.DurationYearMonthField(
                blank=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="diabetesinitialreview",
            name="dx_estimated_date",
            field=models.DateField(
                editable=False,
                help_text="Calculated based on response to `dx_ago`",
                null=True,
                verbose_name="Estimated diagnoses date",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="diabetes_in_household",
            field=models.CharField(
                choices=[
                    ("No", "No"),
                    ("yes_spouse", "Yes, my spouse"),
                    ("yes_parents", "Yes, one of my parents living with me"),
                    ("yes_relative", "Yes, another relative living with me"),
                ],
                max_length=25,
                verbose_name="Do you know if anyone else in your household has <u>diabetes</u>?",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="excercise_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Regular exercise is important for people with <u>high blood pressure</u> or <u>high blood sugar</u> even if they are taking medicines for these conditions.",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="hiv_in_household",
            field=models.CharField(
                choices=[
                    ("No", "No"),
                    ("yes_spouse", "Yes, my spouse"),
                    ("yes_parents", "Yes, one of my parents living with me"),
                    ("yes_relative", "Yes, another relative living with me"),
                ],
                max_length=25,
                verbose_name="Do you know if anyone else in your household has <u>HIV</u>?",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="hypertension_in_household",
            field=models.CharField(
                choices=[
                    ("No", "No"),
                    ("yes_spouse", "Yes, my spouse"),
                    ("yes_parents", "Yes, one of my parents living with me"),
                    ("yes_relative", "Yes, another relative living with me"),
                ],
                max_length=25,
                verbose_name="Do you know if anyone else in your household has <u>high blood pressure</u>?",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="stop_diabetes_meds_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="It is best to stop taking <u>blood sugar</u> medicines when you feel better and start pill taking again when you feel sick",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="stop_hypertension_meds_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="It is best to stop taking <u>blood pressure</u> pills when you feel better and start pill taking again when you feel sick",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="take_medicine_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Drugs for <u>blood sugar</u> and <u>blood pressure</u> can make you unwell",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="traditional_diabetes_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Herbs and traditional medicine are better for managing <u>diabetes</u> than pills and medicines",
            ),
        ),
        migrations.AlterField(
            model_name="familyhistory",
            name="traditional_hypertension_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Herbs and traditional medicine are better for managing <u>blood pressure</u> than pills and medicines",
            ),
        ),
        migrations.AlterField(
            model_name="historicalclinicalreviewbaseline",
            name="hiv_dx",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                editable=False,
                max_length=15,
                null=True,
                verbose_name="Was the patient diagnosed with HIV infection?",
            ),
        ),
        migrations.AlterField(
            model_name="historicaldiabetesinitialreview",
            name="dx_ago",
            field=edc_model.models.fields.duration.DurationYearMonthField(
                blank=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="historicaldiabetesinitialreview",
            name="dx_estimated_date",
            field=models.DateField(
                editable=False,
                help_text="Calculated based on response to `dx_ago`",
                null=True,
                verbose_name="Estimated diagnoses date",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="diabetes_in_household",
            field=models.CharField(
                choices=[
                    ("No", "No"),
                    ("yes_spouse", "Yes, my spouse"),
                    ("yes_parents", "Yes, one of my parents living with me"),
                    ("yes_relative", "Yes, another relative living with me"),
                ],
                max_length=25,
                verbose_name="Do you know if anyone else in your household has <u>diabetes</u>?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="excercise_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Regular exercise is important for people with <u>high blood pressure</u> or <u>high blood sugar</u> even if they are taking medicines for these conditions.",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="hiv_in_household",
            field=models.CharField(
                choices=[
                    ("No", "No"),
                    ("yes_spouse", "Yes, my spouse"),
                    ("yes_parents", "Yes, one of my parents living with me"),
                    ("yes_relative", "Yes, another relative living with me"),
                ],
                max_length=25,
                verbose_name="Do you know if anyone else in your household has <u>HIV</u>?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="hypertension_in_household",
            field=models.CharField(
                choices=[
                    ("No", "No"),
                    ("yes_spouse", "Yes, my spouse"),
                    ("yes_parents", "Yes, one of my parents living with me"),
                    ("yes_relative", "Yes, another relative living with me"),
                ],
                max_length=25,
                verbose_name="Do you know if anyone else in your household has <u>high blood pressure</u>?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="stop_diabetes_meds_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="It is best to stop taking <u>blood sugar</u> medicines when you feel better and start pill taking again when you feel sick",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="stop_hypertension_meds_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="It is best to stop taking <u>blood pressure</u> pills when you feel better and start pill taking again when you feel sick",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="take_medicine_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Drugs for <u>blood sugar</u> and <u>blood pressure</u> can make you unwell",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="traditional_diabetes_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Herbs and traditional medicine are better for managing <u>diabetes</u> than pills and medicines",
            ),
        ),
        migrations.AlterField(
            model_name="historicalfamilyhistory",
            name="traditional_hypertension_tf",
            field=models.CharField(
                choices=[
                    ("true", "True"),
                    ("false", "False"),
                    ("dont_know", "Don't know"),
                ],
                max_length=25,
                verbose_name="Herbs and traditional medicine are better for managing <u>blood pressure</u> than pills and medicines",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhivinitialreview",
            name="dx_ago",
            field=edc_model.models.fields.duration.DurationYearMonthField(
                blank=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="historicalhivinitialreview",
            name="dx_estimated_date",
            field=models.DateField(
                editable=False,
                help_text="Calculated based on response to `dx_ago`",
                null=True,
                verbose_name="Estimated diagnoses date",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhypertensioninitialreview",
            name="dx_ago",
            field=edc_model.models.fields.duration.DurationYearMonthField(
                blank=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="historicalhypertensioninitialreview",
            name="dx_estimated_date",
            field=models.DateField(
                editable=False,
                help_text="Calculated based on response to `dx_ago`",
                null=True,
                verbose_name="Estimated diagnoses date",
            ),
        ),
        migrations.AlterField(
            model_name="hivinitialreview",
            name="dx_ago",
            field=edc_model.models.fields.duration.DurationYearMonthField(
                blank=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="hivinitialreview",
            name="dx_estimated_date",
            field=models.DateField(
                editable=False,
                help_text="Calculated based on response to `dx_ago`",
                null=True,
                verbose_name="Estimated diagnoses date",
            ),
        ),
        migrations.AlterField(
            model_name="hypertensioninitialreview",
            name="dx_ago",
            field=edc_model.models.fields.duration.DurationYearMonthField(
                blank=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="hypertensioninitialreview",
            name="dx_estimated_date",
            field=models.DateField(
                editable=False,
                help_text="Calculated based on response to `dx_ago`",
                null=True,
                verbose_name="Estimated diagnoses date",
            ),
        ),
        migrations.AlterField(
            model_name="medications",
            name="refill_diabetes",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if subject has not been diagnosed and prescribed medication for Diabetes.",
                max_length=25,
                verbose_name="Is the patient filling / refilling Diabetes medications?",
            ),
        ),
        migrations.AlterField(
            model_name="medications",
            name="refill_hiv",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if subject has not been diagnosed and prescribed medication for HIV infection.",
                max_length=25,
                verbose_name="Is the patient filling / refilling HIV medications?",
            ),
        ),
        migrations.AlterField(
            model_name="medications",
            name="refill_hypertension",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if subject has not been diagnosed and prescribed medication for Hypertension.",
                max_length=25,
                verbose_name="Is the patient filling / refilling Hypertension medications?",
            ),
        ),
    ]
