# Generated by Django 3.0.9 on 2020-09-10 16:04

import django.core.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("inte_lists", "0007_auto_20200910_1742"),
        ("inte_subject", "0048_auto_20200910_1742"),
    ]

    operations = [
        migrations.AddField(
            model_name="historicalhealtheconomicsrevised",
            name="healthcare_expenditure_total_month_today",
            field=models.IntegerField(
                default=0,
                help_text="In local currency",
                validators=[django.core.validators.MinValueValidator(0)],
                verbose_name="How much in total has been spent on your healthcare in the last month?",
            ),
            preserve_default=False,
        ),
        migrations.AlterField(
            model_name="clinicalreview",
            name="dm_reason",
            field=models.ManyToManyField(
                blank=True,
                related_name="dm_reason",
                to="inte_lists.ReasonsForTesting",
                verbose_name="Why was the patient tested for diabetes?",
            ),
        ),
        migrations.AlterField(
            model_name="clinicalreview",
            name="htn_reason",
            field=models.ManyToManyField(
                blank=True,
                related_name="htn_test_reason",
                to="inte_lists.ReasonsForTesting",
                verbose_name="Why was the patient tested for hypertension?",
            ),
        ),
        migrations.AlterField(
            model_name="clinicalreviewbaseline",
            name="dm_test_estimated_datetime",
            field=models.DateTimeField(
                blank=True,
                help_text="calculated by the EDC using `dm_test_ago`",
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="clinicalreviewbaseline",
            name="hiv_test_estimated_datetime",
            field=models.DateTimeField(
                blank=True,
                editable=False,
                help_text="calculated by the EDC using `hiv_test_ago`",
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="clinicalreviewbaseline",
            name="htn_test_estimated_datetime",
            field=models.DateTimeField(
                blank=True,
                help_text="calculated by the EDC using `htn_test_ago`",
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="historicalclinicalreviewbaseline",
            name="dm_test_estimated_datetime",
            field=models.DateTimeField(
                blank=True,
                help_text="calculated by the EDC using `dm_test_ago`",
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="historicalclinicalreviewbaseline",
            name="hiv_test_estimated_datetime",
            field=models.DateTimeField(
                blank=True,
                editable=False,
                help_text="calculated by the EDC using `hiv_test_ago`",
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="historicalclinicalreviewbaseline",
            name="htn_test_estimated_datetime",
            field=models.DateTimeField(
                blank=True,
                help_text="calculated by the EDC using `htn_test_ago`",
                null=True,
            ),
        ),
    ]
